import glob
import re

# <td style="background-color: #aabdcc;">https://www.google.com/accounts/o8/id?id=AItOawmbGW3Ot_KHD9yjCwyigJol08xOlPCRGUQ<td>summarize <td>2011/01/06 16:31:00

ROW_RE = re.compile("<td style=.background-color: #......;.>htt[^<]*</td><td>([^<]*)</td><td>20../../.. (..):..:..</td>")

sanity = set("""whatisrenustile
kommt
sausalito
9371354
kommiblankkommtrat
sierra
carbrand
uniform
mike
alfa
romeo
alfaromeo
india
zulu
echo
renu
choral
onjukubeach
tile
what
blank
kommtblankkommtrat
partc
duetsteviewonder
rat
skew
clipaloe
flower
bipolar
summarize
partb
zeit
checkcheck
chibabeach
onjuku
ebonyandivory
hearty
scout
doublecheck
eclair
sunlight
martin
calliope""".split("\n"))

total = {}
stupid = {}

def Main():
  for hour in range(0, 24):
      total[hour] = 0
      stupid[hour] = 0
  for fname in glob.glob("L*.html"):
    for raw_row in open(fname).read().split("<tr>"):
      m = ROW_RE.match(raw_row)
      if not m: continue
      (guess, hour_s) = m.groups()
      guess = guess.strip()
      hour_i = int(hour_s) + 17
      while hour_i >= 24: hour_i -= 24
      total[hour_i] += 1
      if not guess in sanity: stupid[hour_i] += 1

  for hour in range(0, 23):
      hour_s = "%02d" % hour
      if total[hour] < 1: 
          print hour_s, "??"
      else:
          print hour_s, stupid[hour] * 100 / total[hour], total[hour]

Main()
